/* CS6 - Channel Services src/parse_create.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_create(char *who, char *rest)
{  

   struct regsinfo *regs, *regstmp;
   char *chan = NULL, *host = NULL, *numeric = NULL, *nwho = NULL, *stamp = NULL, servnum[3], *server = NULL, nrest[10000], *usernum = NULL;   
   char *ptr[12], *p = NULL, *chans = NULL;
   int i = 0;

   servnum[0] = '\0'; 
   nrest[0] = '\0';
   ptr[0] = '\0'; 
   if(joined == FALSE)
   {
      strcpy(nrest, rest);
      if(stamp = strrchr(nrest, ' ')) *stamp++ = '\0';
      chans=strtok(rest, " ");
      if((p = strtok(chans, ",")) != NULL) ptr[i++] = p;
      strlwr(p);
      if(chan_check(p, who) == -1) return;
      while((p = strtok(NULL, ",")) != NULL && i < 11) ptr[i++] = p;
      ptr[i] = NULL;
      i = 0;
      while(ptr[i])
      {
	 server=num2serv(*who);
	 nwho = num2nick(who);
	 if(chan_check(ptr[i], nwho) == -1) return;
	 add_joininfo(ptr[i], who, TRUE, time(NULL));
	 replace_onode(ptr[i], who, TRUE);
	 i++;
      }
      return;
   }
   if(stamp = strrchr(rest, ' ')) *stamp++ = '\0';
   chans=strtok(rest, " ");
   if((p = strtok(chans, ",")) != NULL) ptr[i++] = p;
   strlwr(p);
   if(chan_check(p, who) == -1) return;
   while((p = strtok(NULL, ",")) != NULL && i < 11) ptr[i++] = p;
   ptr[i] = NULL;
   i = 0;
   while(ptr[i])
   {
      server=num2serv(*who);
      nwho = num2nick(who);
      if(strcasecmp(nwho, bot.nick))
      {
	 if(chan_check(ptr[i], nwho) == -1) return;
	 add_joininfo(ptr[i], who, TRUE, time(NULL));
	 replace_onode(ptr[i], who, TRUE);
	 regs = return_regsinfo(ptr[i]);
	 if(regs != NULL)
	 {
	    if(!regs->suspend)
	    {
	       usernum=get_usernum(bot.nick);
	       send_to_server(":%s JOIN %s\n", botnick, ptr[i]);
	       send_to_server(":%s MODE %s +o %s %lu\n", myserver, ptr[i], usernum, atol(stamp));
	       deopall(bot.nick, ptr[i]);
               load_banfiles(ptr[i]);
               show_welcome(who, ptr[i]);
               check_single_ban_time(ptr[i]);
               enforce_ban(ptr[i], nwho);
	    }
	    else
	       send_to_server(":%s NOTICE %s : This Channel is registered, but is Suspended\n", botnick, who);
	 }
      }
      i++;
   }
}
