/* CS6 - Channel Services src/parse_part.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_part(char *who, char *rest)
{
   struct regsinfo *regs;
   struct nickinfo *nick;
   struct chaninfo *chan;
   char *host = NULL, *msg = NULL, *p = NULL, *ptr[12], kban[1000];
   int i = 0;
   long timestmp;

   ptr[0] = '\0';
   if(msg = strchr(rest, ' ')) *msg++ = '\0';
   if((p = strtok(rest, ",")) != NULL) ptr[i++] = p;
   strlwr(p);
   while((p = strtok(NULL, ",")) != NULL && i < 11) ptr[i++] = p;
   ptr[i] = NULL;
   i = 0;
   while(ptr[i])
   {
      regs = return_regsinfo(ptr[i]);
      timestmp = time(NULL);
      nick = nickhead;
      while(nick != NULL)
      {
	 if(!strcasecmp(nick->nick, who))
	 {
	    chan = nick->chanhead;
	    while(chan != NULL)
	    {
	       if(!strcasecmp(ptr[i], chan->channel) && ison(ptr[i]) && regs->joinpart)
	       {
		  if(timestmp - chan->timestmp <= 4 && timestmp - chan->timestmp >= 0)
		  {
		     sprintf(kban, "%s %s %s join/part to fast Ban for %s", chan->channel, who, regs->jptime, regs->jptime);
		     kick_ban(botnick, kban);
		  }
	       }
	       chan = chan->next;
	    }
	 }
	 nick = nick->next;
      }
      delete_cnode(ptr[i], who);
      regs = return_regsinfo(ptr[i]);
      if(regs != NULL)
      {
	 if(!regs->stay)
	 {
	    nick = nickhead;
	    while(nick != NULL)
	    {
	       if(strcasecmp(nick->nick, bot.nick))
	       {
		  chan = nick->chanhead;
		  while(chan != NULL)
		  {
		     if(!strcasecmp(ptr[i], chan->channel)) return;
		     chan = chan->next;
		  }
	       }
	       nick = nick->next;
	    }
	    send_to_server(":%s PART %s\n", bot.nick, ptr[i]);
	 }
      }
      i++;
   }
}
