/* CS6 - Channel Services src/parse_srvmsg.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_server_msg(fd_set *read_fds)
{
   int i;
   char *botnum;

   if(FD_ISSET(socketfd, read_fds))
   {
      if(readln() > 0) 
      {
	 parse(line);
      }
      else 
      {
         if(trk_servers >= no_servers) trk_servers = 0;
         strcpy(bot.server, servers[trk_servers].name);
         bot.port = servers[trk_servers].port;
         trk_servers++;
         botnum=get_usernum(bot.nick);
         write_all_files();
         delete_usernum(botnum);
         free_hublist();
         free_nicklist();
         if((i = get_connection(bot.server, bot.port)) != -1)
         {
            log(LOG_FILE, "[%s] Reconnecting to %s\n", date(), bot.server);
            socketfd = i;
            init_bot();
         }
      }
   }
}

void parse_connect(char *who, char *rest)
{
}
void parse_ping(char *who, char *rest)
{
   send_to_server("PONG %s\n", who);
   bot.server_active = TRUE;
}


void parse_pong(char *who, char *rest)
{
   char *ptr = NULL;

   if(ptr = strchr(rest, ' ')) *ptr = '\0';
   if(!strcasecmp(who, rest)) bot.server_active = TRUE;
}

void parse_squit(char *who, char *rest)
{
   char *server = NULL;

   free_maplist();
   end_map = 0;
   send_to_server(":%s MAP\n", bot.nick);
   server = strtok(rest, " ");
   remove_hub(server,NULL);
}

void parse_pass(char *who, char *rest)
{
   char *usernum = NULL;

   usernum=get_free_usernum(bot.nick);
   send_to_server("%c NICK %s 1 %lu %s %s DQx8MG %s :%s\n", convert2y[server_num], bot.nick, time(NULL), ircuser, myhost, usernum, ircname);
   add_nickinfo(bot.nick, ircuser, myserver, usernum, myserver, reason);
   send_to_server(":%s MODE %s :%s\n", bot.nick, bot.nick, mymodes);
   bot.server_active = TRUE;
   alarm(ALARMINTERVAL);
}

