/* CS6 - Channel Services src/rename_channel.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include<bot.h>

void renchan(char *who, char *rest)
{
   struct regsinfo *regs;
   char chanopt[10000], chanopt1[10000], chanusr[10000], chanusr1[10000], chaninfo[10000], chaninfo1[10000], *helpname = NULL;
   char *newchan = NULL, *oldchan = NULL, *chan1 = NULL, test1[10000], *nwho = NULL, *usernum = NULL, *ochan = NULL, *nchan = NULL, chanban[10000], chanban1[10000];

   chanopt[0] = '\0';
   chanopt1[0] = '\0';
   chanusr[0] = '\0';
   chanusr1[0] = '\0';
   chaninfo[0] = '\0';
   chaninfo1[0] = '\0';
   test1[0] = '\0';
   chanban[0] = '\0';
   chanban1[0] = '\0';
   nwho = nick2num(who);
   oldchan = strtok(rest, " ");
   strlwr(oldchan);
   if(chan_check(oldchan, who) == -1) return;
   if(check(oldchan, who) == -1) return;
   newchan = strtok(NULL, " ");
   helpname = get_command_name("renchan");
   if(newchan == NULL)
   {
      do_help(who, helpname);
      return;
   }
   strlwr(newchan);
   strcpy(test1, newchan);
   chan1 = test1;
   while(*chan1)
   {
      if(!isascii(*chan1))
      {
	 send_to_server(":%s NOTICE %s : Sorry we can only allow valid ascii characters\n", bot.nick, nwho);
	 return;
      }
      *chan1++;
   }
   if(chan_check(newchan, who) == -1) return;
   if(check_chan(newchan))
   {
      send_to_server(":%s NOTICE %s :Channel %s is already registered.\n", bot.nick, nwho, newchan);
      return;
   }
   ochan=conv_char(oldchan);
   nchan=conv_char(newchan);
   regs = regshead;
   while(regs != NULL)
   {
      if(!strcasecmp(regs->channel, oldchan))
      {
	 strcpy(regs->channel, newchan);
	 break;
      }
      regs = regs->next;
   }
   usernum=get_usernum(bot.nick);
   sprintf(chanopt, "database/chanopt/%s", oldchan);
   sprintf(chanopt1, "database/chanopt/%s", newchan);
   sprintf(chanusr, "database/chanusr/%s", oldchan);
   sprintf(chanusr1, "database/chanusr/%s", newchan);
   sprintf(chaninfo, "database/chaninfo/%s", oldchan);
   sprintf(chaninfo1, "database/chaninfo/%s", newchan);
   sprintf(chanban, "database/chanban/%s", oldchan);
   sprintf(chanban1, "database/chanban/%s", newchan);
   send_to_server(":%s PART %s\n", bot.nick, oldchan);
   delete_cnode(oldchan, bot.nick);
   rename(chanopt, chanopt1);
   rename(chanusr, chanusr1);
   rename(chaninfo, chaninfo1);
   rename(chanban, chanban1);
   send_to_server(":%s JOIN %s\n", bot.nick, newchan);
   add_joininfo(newchan, usernum, TRUE, time(NULL));
   send_to_server(":%s MODE %s +o %s\n", myserver, newchan, usernum);
   send_to_server(":%s TOPIC %s\n", bot.nick, newchan);
   send_to_server(":%s MODE %s\n", bot.nick, newchan);
}
