/* CS6 - Channel Services src/parse_join.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_join(char *who, char *rest)
{
   struct userinfo *tmp, *tmp1, *mask;
   struct authinfo *admnauth, *authtmp;
   struct regsinfo *tmp2;
   struct nickinfo *current, *tmp3;
   char *ptr[12], *p = NULL, *server = NULL, *numeric = NULL, infoline[1500], *ptr1 = NULL, *opcmd = NULL;
   int got_ops = 0, oplvl = 0;
   int i = 0;

   infoline[0] = '\0';
   ptr[0] = '\0';
   opcmd = get_command_name("op");
   oplvl = get_command_level(opcmd);
   if((p = strtok(rest, ",")) != NULL) ptr[i++] = p;
   strlwr(p);
   while((p = strtok(NULL, ",")) != NULL && i < 11) ptr[i++] = p;
   ptr[i] = NULL;
   i = 0;
   while(ptr[i])
   {
      if(strchr(ptr[i], ' '))
	 if(ptr1 = strchr(ptr[i], ' ')) *ptr1++ = '\0';
      tmp2 = return_regsinfo(ptr[i]);
      got_ops = 0;
      if(joined)
      {
	 if(tmp2 != NULL && !tmp2->suspend)
	 {
	    show_welcome(who, ptr[i]);
	    check_single_ban_time(ptr[i]);
	    enforce_ban(ptr[i], who);
	 }
      }
      numeric = nick2num(who);
      server=num2serv(*numeric);
      if(*ptr[i] == '#' || *ptr[i] == '+')
      {
	 if(ison(ptr[i]))
	 {
	    tmp3 = return_nickinfo(who);
	    if(tmp2->operop && tmp3->is_oper && !tmp2->noops && !tmp2->suspend && tmp2->autoops)
	    {
	       send_to_server(":%s MODE %s +o %s\n", bot.nick, ptr[i], numeric);
	       got_ops = 1;
	    }
	    tmp = return_userinfo(who, ptr[i]);
	    do_voice(who, ptr[i]);
	    mask = return_maskinfo(who, ptr[i]);
	    if(mask != NULL && strlen(mask->info) > 0 && !tmp2->suspend)
	    {
	       sprintf(infoline, "[%s] %s", mask->nick, mask->info);
	       send_to_server(":%s PRIVMSG %s :%s\n", bot.nick, ptr[i], infoline);
	    }
	    if(tmp != NULL && !tmp2->suspend)
	    {
	       current = nickhead;
	       if(tmp->autoop && tmp2->autoops && !tmp2->noops)
	       {
		  while(current != NULL)
		  {
		     if(!strcasecmp(who,current->nick))
		     {
			authtmp = return_authinfo(ptr[i], who);
			if(authtmp != NULL && !got_ops && tmp->level >= oplvl)
			{
			   send_to_server(":%s MODE %s +o %s\n", bot.nick, ptr[i], numeric);
			   got_ops = 1;
			}
		     }
		     current = current->next;
		  }
	       }
	    }
	    else
	    {
	       tmp1 = return_userinfo(who, csadminchan);
	       if(tmp1 != NULL && !tmp2->suspend)
	       {
		  if(tmp1->autoop && !tmp2->noops && tmp2->autoops)
		  {
		     current = nickhead;
		     while(current != NULL)
		     {
			if(!strcasecmp(who,current->nick))
			{
			   admnauth = return_authinfo(csadminchan, who);
			   if(admnauth != NULL && !got_ops)
			   {
			      send_to_server(":%s MODE %s +o %s\n", bot.nick, ptr[i], numeric);
			      got_ops = 1;
			   }
			}
			current = current->next;
		     }
		  }
	       }
	    }
	 }
	 if(got_ops)
	    add_joininfo(ptr[i], numeric, TRUE, time(NULL));
	 else
	    add_joininfo(ptr[i], numeric, FALSE, time(NULL));
      }
      i++;
   }
}

