/* CS6 - Channel Services src/parse_rtnmsg.c
 * CS5.0, CS5.1 and CS6.0 Copyright  1998-1999 Chris Birch(IRCore)
 */

#include <bot.h>

void parse_action(char *who, char *rest)
{
}

void parse_away(char *who, char *rest)
{
   struct nickinfo *current;

   current = nickhead;
   while(current != NULL)
   {
      if(!strcasecmp(who, current->nick))
      {
	 if(rest == NULL)
	 {
	    strcpy(current->away, "H");
	 }
	 else
	 {
	    strcpy(current->away, "G");
	 }
	 return;
      }
      current = current->next;
   }
}

void parse_367(char *who, char *rest)
{
   char *chan = NULL, *ban_nick = NULL, *ptr = NULL;

   if(chan = strchr(rest, ' ')) *chan++ = '\0';
   if(ban_nick = strchr(chan, ' ')) *ban_nick++ = '\0';
   if(ptr = strchr(ban_nick, ' ')) *ptr = '\0';
   add_baninfo(chan, ban_nick, time(NULL), 0, 0, NULL, who, 0);
}

void parse_353(char *who, char *rest)
{
   char *parv[100], buff[10000], md[100], *nicklist = NULL, *ptr = NULL, *chan = NULL;
   int i = 0, j = 0, n = 0;

   parv[0] = '\0';
   buff[0] = '\0';
   md[0] = '\0';
   if(nicklist = strchr(rest, ':')) *nicklist++ = '\0';
   if(ptr = strrchr(rest, ' ')) *ptr = '\0';
   if(chan = strrchr(rest, ' ')) *chan++ = '\0';
   trailing_blanks(chan);
   ptr = strtok(nicklist, " ");
   if(*ptr == '@')
      if(strcasecmp(++ptr, bot.nick)) parv[i++] = ptr;
   while((ptr = strtok(NULL, " ")) != NULL)
   {
      if(*ptr == '@')
	 if(strcasecmp(++ptr, bot.nick)) parv[i++] = ptr;
   }
   parv[i] = "%";
   parv[i+1] = NULL;
   if(parv[0][0] != '%')
   {
      strcpy(md, "-o");
      strcpy(buff, parv[0]);
   }
   i = 1;
   while(parv[i] != NULL)
   {
      if(j < 5 && parv[i][0] != '%')
      {
	 if(strcasecmp(parv[i], bot.nick))
	 {
	    strcat(buff, " ");
	    strcat(buff, parv[i]);
	    j++;
	 }
      }
      else
      {
	 for(n = 0; n < j; n++) strcat(md, "o");
	 send_to_server(":%s MODE %s %s %s\n", bot.nick, chan, md, buff);
	 strcpy(buff, parv[i]);
	 strcpy(md, "-o");
	 j = 0;
      }
      i++;
   }
}

void parse_007(char *who, char *rest)
{
   end_map = 1;
   return;
}

void parse_005(char *who, char *rest)
{
   char *nwho = NULL, *map = NULL, nmap[1000];

   nmap[0] = '\0';
   if(!end_map)
   {
      nwho = nick2num(who);
      map = strchr(rest, ':');
      sprintf(nmap, "%s\n", map);
      add_mapinfo(nmap);
   }
   return;
}

void parse_332(char *who, char *rest)
{
   char *ptr = NULL, *topic = NULL;

   if(ptr = strchr(rest, ' ')) *ptr++ = '\0';
   if(topic = strchr(ptr, ':')) *topic++ = '\0';
   trailing_blanks(ptr);
   add_topic(ptr, topic);
}

void parse_324(char *who, char *rest)
{
   char *chan = NULL, *mode = NULL, *remain = NULL;

   trailing_blanks(rest);
   if(chan = strchr(rest, ' ')) *chan++ = '\0';
   if(mode = strchr(chan, ' ')) *mode++ = '\0';
   replace_mnode(chan, mode);
}
